## mingw-w64-gnuradio-3.10.11.0-10.src.tar.zst

=== gr-dtv/lib/CMakeLists.txt ===
# Copyright 2014,2015,2016 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup library
########################################################################
add_library(
    gnuradio-dtv
    atsc/atsc_plinfo.cc
    atsc/atsc_deinterleaver_impl.cc
    atsc/atsc_depad_impl.cc
    atsc/atsc_derandomizer_impl.cc
    atsc/atsc_equalizer_impl.cc
    atsc/atsc_fpll_impl.cc
    atsc/atsc_fs_checker_impl.cc
    atsc/atsc_randomize.cc
    atsc/atsc_rs_decoder_impl.cc
    atsc/atsc_sync_impl.cc
    atsc/atsc_fake_single_viterbi.cc
    atsc/atsc_single_viterbi.cc
    atsc/atsc_viterbi_decoder_impl.cc
    atsc/atsc_pad_impl.cc
    atsc/atsc_randomizer_impl.cc
    atsc/atsc_rs_encoder_impl.cc
    atsc/atsc_interleaver_impl.cc
    atsc/atsc_basic_trellis_encoder.cc
    atsc/atsc_trellis_encoder_impl.cc
    atsc/atsc_field_sync_mux_impl.cc
    dvb/dvb_bbheader_bb_impl.cc
    dvb/dvb_bbscrambler_bb_impl.cc
    dvb/dvb_bch_bb_impl.cc
    dvb/dvb_ldpc_bb_impl.cc
    dvbt2/dvbt2_interleaver_bb_impl.cc
    dvbt2/dvbt2_modulator_bc_impl.cc
    dvbt2/dvbt2_cellinterleaver_cc_impl.cc
    dvbt2/dvbt2_framemapper_cc_impl.cc
    dvbt2/dvbt2_freqinterleaver_cc_impl.cc
    dvbt2/dvbt2_pilotgenerator_cc_impl.cc
    dvbt2/dvbt2_paprtr_cc_impl.cc
    dvbt2/dvbt2_p1insertion_cc_impl.cc
    dvbt2/dvbt2_miso_cc_impl.cc
    dvbs2/dvbs2_interleaver_bb_impl.cc
    dvbs2/dvbs2_modulator_bc_impl.cc
    dvbs2/dvbs2_physical_cc_impl.cc
    dvbt/dvbt_energy_dispersal_impl.cc
    dvbt/dvbt_reed_solomon_enc_impl.cc
    dvbt/dvbt_convolutional_interleaver_impl.cc
    dvbt/dvbt_configure.cc
    dvbt/dvbt_inner_coder_impl.cc
    dvbt/dvbt_bit_inner_interleaver_impl.cc
    dvbt/dvbt_symbol_inner_interleaver_impl.cc
    dvbt/dvbt_map_impl.cc
    dvbt/dvbt_reference_signals_impl.cc
    dvbt/dvbt_ofdm_sym_acquisition_impl.cc
    dvbt/dvbt_demod_reference_signals_impl.cc
    dvbt/dvbt_demap_impl.cc
    dvbt/dvbt_bit_inner_deinterleaver_impl.cc
    dvbt/dvbt_viterbi_decoder_impl.cc
    dvbt/dvbt_convolutional_deinterleaver_impl.cc
    dvbt/dvbt_reed_solomon_dec_impl.cc
    dvbt/dvbt_energy_descramble_impl.cc
    catv/catv_transport_framing_enc_bb_impl.cc
    catv/catv_reed_solomon_enc_bb_impl.cc
    catv/catv_randomizer_bb_impl.cc
    catv/catv_frame_sync_enc_bb_impl.cc
    catv/catv_trellis_enc_bb_impl.cc)

target_link_libraries(
    gnuradio-dtv
    PUBLIC gnuradio-runtime
    PRIVATE gnuradio-analog gnuradio-filter gnuradio-fec Volk::volk)

if(ENABLE_COMMON_PCH)
    target_link_libraries(gnuradio-dtv PRIVATE common-precompiled-headers)
endif()

target_include_directories(
    gnuradio-dtv PUBLIC $<INSTALL_INTERFACE:include>
                        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

include(CheckCCompilerFlag)
if(MSVC)
    # 64-bit MSVC always supports SSE2
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(SSE2_SUPPORTED true)
    else()
        check_c_compiler_flag("/arch:SSE2" SSE2_SUPPORTED)
    endif(CMAKE_SIZEOF_VOID_P EQUAL 8)
else()
    # The "correct" way to test this would be to run
    # check_c_compiler_flag("-msse2")
    # ...but that's not reliable, in particular, on Clang and ARM, it will
    # return TRUE when it shouldn't. Hence, we compile this snippet
    # manually.
    check_c_source_compiles(
        "#include <emmintrin.h>\nint main(){__m128i m0, m1, m2; m0 = _mm_add_epi8(m1, m2);}"
        SSE2_SUPPORTED)
endif(MSVC)

if(SSE2_SUPPORTED)
    if(NOT MSVC)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
    else()
        if(CMAKE_SIZEOF_VOID_P EQUAL 4)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:SSE2")
        endif()
    endif()
    target_compile_definitions(gnuradio-dtv PRIVATE -DDTV_SSE2)
endif(SSE2_SUPPORTED)

#Add Windows DLL resource file if using MSVC
if(MSVC)
    include(${PROJECT_SOURCE_DIR}/cmake/Modules/GrVersion.cmake)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-dtv.rc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-dtv.rc @ONLY)

    target_sources(gnuradio-dtv PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-dtv.rc)
endif(MSVC)

if(BUILD_SHARED_LIBS)
    gr_library_foo(gnuradio-dtv)
endif()

=== gr-fec/examples/CMakeLists.txt ===
# Copyright 2014 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

include(GrPython)

install(
    FILES ber_curve_gen.grc
          ber_curve_gen_ldpc.grc
          ber_test.grc
          fecapi_async_decoders.grc
          fecapi_async_encoders.grc
          fecapi_async_ldpc_decoders.grc
          fecapi_async_ldpc_encoders.grc
          fecapi_async_packed_decoders.grc
          fecapi_async_to_stream.grc
          fecapi_cc_decoders.grc
          fecapi_decoders.grc
          fecapi_encoders.grc
          fecapi_ldpc_decoders.grc
          fecapi_ldpc_encoders.grc
          fecapi_polar_async_packed_decoders.grc
          fecapi_polar_decoders.grc
          fecapi_polar_encoders.grc
          fecapi_tagged_decoders.grc
          fecapi_tagged_encoders.grc
          fecapi_tagged_ldpc_decoders.grc
          fecapi_tagged_ldpc_encoders.grc
          polar_ber_curve_gen.grc
          polar_code_example.grc
          tpc_ber_curve_gen.grc
    DESTINATION ${GR_PKG_FEC_EXAMPLES_DIR})

=== gr-iio/examples/CMakeLists.txt ===
# Copyright 2021 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

install(
    FILES
    DESTINATION ${GR_PKG_IIO_EXAMPLES_DIR}
    COMPONENT "iio_python")

=== gr-zeromq/grc/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

install(FILES
    zeromq_pub_sink.block.yml
    zeromq_pub_msg_sink.block.yml
    zeromq_sub_source.block.yml
    zeromq_sub_msg_source.block.yml
    zeromq_push_sink.block.yml
    zeromq_push_msg_sink.block.yml
    zeromq_pull_source.block.yml
    zeromq_pull_msg_source.block.yml
    zeromq_rep_sink.block.yml
    zeromq_rep_msg_sink.block.yml
    zeromq_req_source.block.yml
    zeromq_req_msg_source.block.yml

    DESTINATION share/gnuradio/grc/blocks
)

=== gnuradio-runtime/lib/pmt/CMakeLists.txt ===
# Copyright 2010-2013,2018-2019 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

add_library(
    gnuradio-pmt
    ${CMAKE_CURRENT_SOURCE_DIR}/pmt_unv.cc ${CMAKE_CURRENT_SOURCE_DIR}/pmt.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/pmt_io.cc ${CMAKE_CURRENT_SOURCE_DIR}/pmt_pool.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/pmt_serialize.cc)

target_link_libraries(
    gnuradio-pmt
    PUBLIC Boost::boost
    PRIVATE Volk::volk)

target_include_directories(
    gnuradio-pmt
    PUBLIC $<INSTALL_INTERFACE:include>
           $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../../include>
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/)

#Add Windows DLL resource file if using MSVC
if(MSVC)
    include(${PROJECT_SOURCE_DIR}/cmake/Modules/GrVersion.cmake)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-pmt.rc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-pmt.rc @ONLY)

    target_sources(gnuradio-pmt PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-pmt.rc)
endif(MSVC)

if(BUILD_SHARED_LIBS)
    gr_library_foo(gnuradio-pmt)
endif()

=== PKGBUILD ===
# Maintainer: Chris Gorman <chrisjohgorman@gmail.com>

_realname=gnuradio
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.10.11.0
pkgrel=10
pkgdesc="General purpose DSP and SDR toolkit (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64')
url='https://gnuradio.org/'
msys2_repository_url="https://github.com/gnuradio/gnuradio"
msys2_references=(
  'archlinux: gnuradio'
)
license=(spdx:GPL-3.0-or-later)
depends=("${MINGW_PACKAGE_PREFIX}-codec2"
  "${MINGW_PACKAGE_PREFIX}-boost-libs"
  "${MINGW_PACKAGE_PREFIX}-gcc-libs"
  "${MINGW_PACKAGE_PREFIX}-gmp"
  "${MINGW_PACKAGE_PREFIX}-gsl"
  "${MINGW_PACKAGE_PREFIX}-gsm"
  "${MINGW_PACKAGE_PREFIX}-gtk3"
  "${MINGW_PACKAGE_PREFIX}-libad9361-iio"
  "${MINGW_PACKAGE_PREFIX}-libiio"
  "${MINGW_PACKAGE_PREFIX}-libuhd" 
  "${MINGW_PACKAGE_PREFIX}-libunwind"
  "${MINGW_PACKAGE_PREFIX}-fftw"
  "${MINGW_PACKAGE_PREFIX}-mathjax2"
  "${MINGW_PACKAGE_PREFIX}-volk"
  "${MINGW_PACKAGE_PREFIX}-python-click"
  "${MINGW_PACKAGE_PREFIX}-python-click-plugins"
  "${MINGW_PACKAGE_PREFIX}-python-gobject"
  "${MINGW_PACKAGE_PREFIX}-python-cairo"
  "${MINGW_PACKAGE_PREFIX}-python-jsonschema"
  "${MINGW_PACKAGE_PREFIX}-python-mako"
  "${MINGW_PACKAGE_PREFIX}-python-matplotlib"
  "${MINGW_PACKAGE_PREFIX}-python-numpy"
  "${MINGW_PACKAGE_PREFIX}-python-pygccxml"
  "${MINGW_PACKAGE_PREFIX}-python-pyaml" 
  "${MINGW_PACKAGE_PREFIX}-python-pyzmq"
  "${MINGW_PACKAGE_PREFIX}-python-scipy"
  "${MINGW_PACKAGE_PREFIX}-python-qtpy"
  "${MINGW_PACKAGE_PREFIX}-python-pyqt5"
  "${MINGW_PACKAGE_PREFIX}-python-pyqtgraph"
  "${MINGW_PACKAGE_PREFIX}-python-lxml"
  "${MINGW_PACKAGE_PREFIX}-python-pyopengl"
  "${MINGW_PACKAGE_PREFIX}-qt5-base"
  "${MINGW_PACKAGE_PREFIX}-angleproject"
  "${MINGW_PACKAGE_PREFIX}-qwt-qt5"
  "${MINGW_PACKAGE_PREFIX}-SDL"
  "${MINGW_PACKAGE_PREFIX}-soapysdr"
  "${MINGW_PACKAGE_PREFIX}-portaudio"
  "${MINGW_PACKAGE_PREFIX}-libsndfile"
  "${MINGW_PACKAGE_PREFIX}-spdlog"
  "${MINGW_PACKAGE_PREFIX}-fmt"
  "${MINGW_PACKAGE_PREFIX}-zeromq")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-cppzmq"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-pybind11"
             "${MINGW_PACKAGE_PREFIX}-python-packaging"
             "${MINGW_PACKAGE_PREFIX}-python-pip")
checkdepends=("${MINGW_PACKAGE_PREFIX}-python-setuptools"
              "${MINGW_PACKAGE_PREFIX}-python-pytest")
optdepends=("${MINGW_PACKAGE_PREFIX}-soapyrtlsdr: install to use RTL-SDR devices with gnuradio")
options=('!strip')
source=("https://github.com/${_realname}/${_realname}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "https://github.com/gnuradio/gnuradio/releases/download/v${pkgver}/${_realname}-${pkgver}.tar.gz.asc"
        0001-cmake-Install-python-wrapper-exe-for-scripts-on-Wind.patch
        https://github.com/gnuradio/gnuradio/commit/16ef847807553d65b80666b238643794b0b93d71.patch
        numpy-2.0.patch
        gnuradio-blocks-and-examples-path.hook.in
        gnuradio-blocks-and-examples-path.script.in
        LICENSE.txt)
validpgpkeys=(
  'B90DDFAC56989BF62262EB812987C77CBB8ED9B2'  # GNU Radio Project (Admin) <admin@gnuradio.org>
  'D74F9F146E7F755783583158B343B2BA293E5174'  # Marcus Müller (GNU Radio Maintainer) <mmueller@gnuradio.org>
  '723EC3A2B90533C6B93DFBC8ED797743F7951435'  # GNU Radio (Software Signing Key) <info@gnuradio.org>
)
sha256sums=('9ca658e6c4af9cfe144770757b34ab0edd23f6dcfaa6c5c46a7546233e5ecd29'
            'SKIP'
            'aa9c79f6ab923c566f57d90117fa7e82549c26230538ffb3a2b1c0246fc31c19'
            '05f60071b421d9bd30cc4744dbaa035581c77dd03e8da94c12083fa619be3868'
            'e3a2d9f63318b56f87829d224232724d9c815b46c6c7086ac3c5b6ae8980bc7b'
            'b2f014a69b32afcb207e4d2e8e163fc04968594d7d4c3184b9ea5c8cf2a29329'
            'caa9a6cc253d508abcd01545f26b46df0d708d24f69b7dc59183d631872721ed'
            '86dc4bc79c9fa4d5dc3ae5558441d5bb8b8736403e70997cf9ae8f671ab5d0ca')
 
prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  # Patch number 0001 is credited to Ryan Volz <ryan.volz@gmail.com> and licensed under the 
  # BSD-3-Clause license
  patch -Np1 -i "${srcdir}/0001-cmake-Install-python-wrapper-exe-for-scripts-on-Wind.patch"
  patch -Np1 -i "${srcdir}/16ef847807553d65b80666b238643794b0b93d71.patch"
  patch -Np1 -i "${srcdir}/numpy-2.0.patch"
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  # FIXME remove -DENABLE_CTRLPORT_THRIFT=OFF when issue 7390 is fixed
  # https://github.com/gnuradio/gnuradio/issues/7390

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBoost_ATOMIC_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_atomic-mt.dll" \
      -DBoost_CHRONO_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_chrono-mt.dll" \
      -DBoost_DATE_TIME_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_date_time-mt.dll" \
      -DBoost_PROGRAM_OPTIONS_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_program_options-mt.dll" \
      -DBoost_REGEX_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_regex-mt.dll" \
      -DBoost_SYSTEM_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_system-mt.dll" \
      -DBoost_THREAD_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_thread-mt.dll" \
      -DBoost_UNIT_TEST_FRAMEWORK_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_unit_test_framework-mt.dll" \
      -DENABLE_CTRLPORT_THRIFT=OFF \
      -S "${_realname}-${pkgver}" \
      -DMATHJAX2_JS_PATH="${MINGW_PREFIX}/share/mathjax2" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

check() {
  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}" --target test || warning "Tests failed"
}

package() {

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  #install hook and script for setting global_blocks_path and examples_path in grc.conf
  hook_path=${srcdir}/${MINGW_PACKAGE_PREFIX}-gnuradio-blocks-and-examples-path.hook
  cp "${srcdir}/gnuradio-blocks-and-examples-path.hook.in" "${hook_path}"
  sed -s "s|@MINGW_PACKAGE_PREFIX@|${MINGW_PACKAGE_PREFIX}|g" -i "${hook_path}"
  install -Dt "$pkgdir/usr/share/libalpm/hooks" -m644 "${hook_path}"

  script_path="${srcdir}/${MINGW_PACKAGE_PREFIX}-gnuradio-blocks-and-examples-path.script";
  cp "${srcdir}/gnuradio-blocks-and-examples-path.script.in" "${script_path}"
  sed -s "s|@MINGW_PREFIX@|${MINGW_PREFIX}|g" -i "${script_path}"
  install -Dt "$pkgdir/usr/share/libalpm/scripts" -m755 "${script_path}"
 
  #install licenses
  install -Dm644 "${srcdir}/${_realname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
  install -Dm644 "${srcdir}/LICENSE.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.txt"
}
